## hypre 2.28.0

=== src/CMakeLists.txt ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

cmake_minimum_required(VERSION 3.13...3.16)

if (${CMAKE_VERSION} VERSION_LESS 3.16)
  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
else ()
  cmake_policy(VERSION 3.16)
endif ()

# The version number.
set(HYPRE_VERSION 2.28.0)
set(HYPRE_NUMBER  22800)
set(HYPRE_DATE    2023/03/17)
set(HYPRE_TIME    00:00:00)
set(HYPRE_BUGS    https://github.com/hypre-space/hypre/issues)
set(HYPRE_SRCDIR  "${PROJECT_SOURCE_DIR}")

set(PROJECT_NAME HYPRE)
project(${PROJECT_NAME}
  VERSION ${HYPRE_VERSION}
  LANGUAGES C)

if (${HYPRE_SOURCE_DIR} STREQUAL ${HYPRE_BINARY_DIR})
  message(FATAL_ERROR "In-place build not allowed! Please use a separate build directory. See the Users Manual or INSTALL file for details.")
endif ()

if (EXISTS ${HYPRE_SOURCE_DIR}/../.git)
  execute_process(COMMAND git -C ${HYPRE_SOURCE_DIR} describe --match v* --long --abbrev=9
                  OUTPUT_VARIABLE develop_string
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  execute_process(COMMAND git -C ${HYPRE_SOURCE_DIR} describe --match v* --abbrev=0
                  OUTPUT_VARIABLE develop_lastag
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  execute_process(COMMAND git -C ${HYPRE_SOURCE_DIR} rev-list --count ${develop_lastag}..HEAD
                  OUTPUT_VARIABLE develop_number
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  execute_process(COMMAND git -C ${HYPRE_SOURCE_DIR} rev-parse --abbrev-ref HEAD
                  OUTPUT_VARIABLE develop_branch
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  if (${develop_string} MATCHES ".*")
    set(HYPRE_DEVELOP_STRING  ${develop_string})
    set(HYPRE_DEVELOP_NUMBER  ${develop_number})
    set(HYPRE_BRANCH_NAME     ${develop_branch})
    if (develop_branch MATCHES "master")
      set(HYPRE_DEVELOP_BRANCH  ${develop_branch})
    else ()
      message(STATUS "NOTE: On branch ${develop_branch}, not the main development branch")
    endif ()
  else ()
    message(STATUS "NOTE: Could not describe development branch")
  endif ()
else ()
  message(STATUS "NOTE: Could not find .git directory")
endif ()

# Set cmake module path
set(CMAKE_MODULE_PATH "${HYPRE_SOURCE_DIR}/config/cmake" "${CMAKE_MODULE_PATH}")
include(HYPRE_CMakeUtilities)

# Set default installation directory, but provide a means for users to change
set(HYPRE_INSTALL_PREFIX "${PROJECT_SOURCE_DIR}/hypre" CACHE PATH
    "Installation directory for HYPRE")
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "${HYPRE_INSTALL_PREFIX}" CACHE INTERNAL "" FORCE)
endif ()

# Set default compile optimization flag
set(HYPRE_BUILD_TYPE "Release" CACHE STRING
    "Optimization flags: set to Debug, Release, RelWithDebInfo, or MinSizeRel")

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE "${HYPRE_BUILD_TYPE}" CACHE INTERNAL "" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif ()

# Configuration options
option(HYPRE_ENABLE_SHARED           "Build a shared library" OFF)
option(HYPRE_ENABLE_BIGINT           "Use long long int for HYPRE_Int" OFF)
option(HYPRE_ENABLE_MIXEDINT         "Use long long int for HYPRE_BigInt, int for HYPRE_INT" OFF)
option(HYPRE_ENABLE_SINGLE           "Use float for HYPRE_Real" OFF)
option(HYPRE_ENABLE_LONG_DOUBLE      "Use long double for HYPRE_Real" OFF)
option(HYPRE_ENABLE_COMPLEX          "Use complex values" OFF)
option(HYPRE_ENABLE_HYPRE_BLAS       "Use internal BLAS library" ON)
option(HYPRE_ENABLE_HYPRE_LAPACK     "Use internal LAPACK library" ON)
option(HYPRE_ENABLE_PERSISTENT_COMM  "Use persistent communication" OFF)
option(HYPRE_ENABLE_FEI              "Use FEI" OFF) # TODO: Add this cmake feature
option(HYPRE_WITH_MPI                "Compile with MPI" ON)
option(HYPRE_WITH_GPU_AWARE_MPI      "Compile with device aware GPU support" OFF)
option(HYPRE_WITH_OPENMP             "Use OpenMP" OFF)
option(HYPRE_ENABLE_HOPSCOTCH        "Use hopscotch hashing with OpenMP" OFF)
option(HYPRE_WITH_SUPERLU            "Use TPL SuperLU" OFF)
option(HYPRE_WITH_DSUPERLU           "Use TPL SuperLU_Dist" OFF)
option(HYPRE_WITH_CALIPER            "Use Caliper" OFF)
option(HYPRE_PRINT_ERRORS            "Print HYPRE errors" OFF)
option(HYPRE_TIMING                  "Use HYPRE timing routines" OFF)
option(HYPRE_BUILD_EXAMPLES          "Build examples" OFF)
option(HYPRE_BUILD_TESTS             "Build tests" OFF)
option(HYPRE_USING_HOST_MEMORY       "Use host memory" ON)
set(HYPRE_WITH_EXTRA_CFLAGS       "" CACHE STRING "Define extra C compile flags")
set(HYPRE_WITH_EXTRA_CXXFLAGS     "" CACHE STRING "Define extra CXX compile flags")
# GPU options
option(HYPRE_WITH_CUDA               "Use CUDA. Require cuda-8.0 or higher" OFF)
option(HYPRE_WITH_SYCL               "Use SYCL" OFF)
option(HYPRE_ENABLE_UNIFIED_MEMORY   "Use unified memory for allocating the memory" OFF)
option(HYPRE_ENABLE_DEVICE_MALLOC_ASYNC "Use device async malloc" OFF)
# CUDA options
option(HYPRE_ENABLE_CUDA_STREAMS     "Use CUDA streams" ON)
option(HYPRE_ENABLE_CUSPARSE         "Use cuSPARSE" ON)
option(HYPRE_ENABLE_CUSOLVER         "Use cuSOLVER" OFF)
option(HYPRE_ENABLE_DEVICE_POOL      "Use device memory pool" OFF)
option(HYPRE_ENABLE_CUBLAS           "Use cuBLAS" OFF)
option(HYPRE_ENABLE_CURAND           "Use cuRAND" ON)
option(HYPRE_ENABLE_GPU_PROFILING    "Use NVTX on CUDA" OFF)
set(HYPRE_CUDA_SM "70" CACHE STRING  "Target CUDA architecture.")
# oneAPI options
option(HYPRE_ENABLE_ONEMKLSPARSE     "Use oneMKL sparse" ON)
option(HYPRE_ENABLE_ONEMKLBLAS       "Use oneMKL blas" ON)
option(HYPRE_ENABLE_ONEMKLRAND       "Use oneMKL rand" ON)
set(HYPRE_SYCL_TARGET            ""   CACHE STRING  "Target SYCL architecture, e.g. 'spir64_gen'.")
set(HYPRE_SYCL_TARGET_BACKEND    ""   CACHE STRING  "Additional SYCL backend options, e.g. '-device 12.1.0,12.4.0'.")
# Umpire resource management options
option(HYPRE_WITH_UMPIRE             "Use Umpire Allocator for device and unified memory" OFF)
option(HYPRE_WITH_UMPIRE_HOST        "Use Umpire Allocator for host memory" OFF)
option(HYPRE_WITH_UMPIRE_DEVICE      "Use Umpire Allocator for device memory" OFF)
option(HYPRE_WITH_UMPIRE_UM          "Use Umpire Allocator for unified memory" OFF)
option(HYPRE_WITH_UMPIRE_PINNED      "Use Umpire Allocator for pinned memory" OFF)
option(TPL_UMPIRE_LIBRARIES          "List of absolute paths to Umpire link libraries [].")
option(TPL_UMPIRE_INCLUDE_DIRS       "List of absolute paths to Umpire include directories [].")

option(TPL_SUPERLU_LIBRARIES         "List of absolute paths to SuperLU link libraries [].")
option(TPL_SUPERLU_INCLUDE_DIRS      "List of absolute paths to SuperLU include directories [].")
option(TPL_DSUPERLU_LIBRARIES        "List of absolute paths to SuperLU_Dist link libraries [].")
option(TPL_DSUPERLU_INCLUDE_DIRS     "List of absolute paths to SuperLU_Dist include directories [].")
option(TPL_BLAS_LIBRARIES            "Optional list of absolute paths to BLAS libraries, otherwise use FindBLAS to locate [].")
option(TPL_LAPACK_LIBRARIES          "Optional list of absolute paths to LAPACK libraries, otherwise use FindLAPACK to locate [].")
option(TPL_FEI_INCLUDE_DIRS          "List of absolute paths to FEI include directories [].")

# Set config name values
if (HYPRE_ENABLE_SHARED)
  set(HYPRE_SHARED ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_BIGINT)
  set(HYPRE_BIGINT ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_MIXEDINT)
  set(HYPRE_MIXEDINT ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_SINGLE)
  set(HYPRE_SINGLE ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_LONG_DOUBLE)
  set(HYPRE_LONG_DOUBLE ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_COMPLEX)
  set(HYPRE_COMPLEX ON CACHE BOOL "" FORCE)
endif ()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(HYPRE_DEBUG ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_HYPRE_BLAS)
  set(HYPRE_USING_HYPRE_BLAS ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_HYPRE_LAPACK)
  set(HYPRE_USING_HYPRE_LAPACK ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_PERSISTENT_COMM)
  set(HYPRE_USING_PERSISTENT_COMM ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_MPI)
  set(HYPRE_HAVE_MPI ON CACHE BOOL "" FORCE)
  set(HYPRE_SEQUENTIAL OFF CACHE BOOL "" FORCE)
else ()
  set(HYPRE_SEQUENTIAL ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_OPENMP)
  set(HYPRE_USING_OPENMP ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_HOPSCOTCH)
  set(HYPRE_HOPSCOTCH ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_SUPERLU)
  set(HYPRE_USING_SUPERLU ON CACHE BOOL "" FORCE)
  add_compile_definitions(HAVE_SUPERLU)
endif ()

if (HYPRE_WITH_DSUPERLU)
  set(HYPRE_USING_DSUPERLU ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_HYPRE_BLAS OFF CACHE BOOL "" FORCE)
  set(HYPRE_USING_HYPRE_LAPACK OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_ENABLE_FEI)
  set(HYPRE_USING_FEI ON CACHE BOOL "" FORCE)
  message(WARNING "CMake support for FEI is not complete!")
endif ()

if (HYPRE_WITH_CALIPER)
  set(HYPRE_USING_CALIPER ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_SHARED OR HYPRE_BIGINT OR HYPRE_SINGLE OR HYPRE_LONG_DOUBLE)
  # FEI doesn't currently compile with shared
  set(HYPRE_USING_FEI OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_SEQUENTIAL)
  set(HYPRE_BUILD_EXAMPLES OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_UMPIRE)
  set(HYPRE_USING_UMPIRE ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_UMPIRE_DEVICE ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_UMPIRE_UM ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_UMPIRE_HOST)
  set(HYPRE_USING_UMPIRE ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_UMPIRE_HOST ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_UMPIRE_DEVICE)
  set(HYPRE_USING_UMPIRE ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_UMPIRE_DEVICE ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_UMPIRE_UM)
  set(HYPRE_USING_UMPIRE ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_UMPIRE_UM ON CACHE BOOL "" FORCE)
endif ()

if (HYPRE_WITH_UMPIRE_PINNED)
  set(HYPRE_USING_UMPIRE ON CACHE BOOL "" FORCE)
  set(HYPRE_USING_UMPIRE_PINNED ON CACHE BOOL "" FORCE)
endif ()

# CUDA
if (HYPRE_WITH_CUDA)
  enable_language(CXX)
  message(STATUS "Enabled support for CXX.")

  # Enforce C++11
  if (NOT CMAKE_CXX_STANDARD OR CMAKE_CXX_STANDARD LESS 11)
    set(CMAKE_CXX_STANDARD 11)
  endif ()
  set(CMAKE_CXX_STANDARD_REQUIRED ON)

  message(STATUS "Using CXX standard: c++${CMAKE_CXX_STANDARD}")

  # Add any extra CXX compiler flags HYPRE_WITH_EXTRA_CXXFLAGS
  if (NOT HYPRE_WITH_EXTRA_CXXFLAGS STREQUAL "")
    string(REPLACE " " ";" HYPRE_WITH_EXTRA_CXXFLAGS "${HYPRE_WITH_EXTRA_CXXFLAGS}")
    add_compile_options("$<$<COMPILE_LANGUAGE:CXX>:${HYPRE_WITH_EXTRA_CXXFLAGS}>")
  endif ()

  # Check if CUDA is available, then enable it
  include(CheckLanguage)
  check_language(CUDA)

  # Use ${CMAKE_CXX_COMPILER} as the cuda host compiler.
  if (NOT CMAKE_CUDA_HOST_COMPILER)
    set(CMAKE_CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})
  endif ()

  if (CMAKE_CUDA_COMPILER)

    enable_language(CUDA)
    message(STATUS "Enabled support for CUDA.")

    if (NOT CMAKE_CUDA_STANDARD OR CMAKE_CUDA_STANDARD EQUAL 98)
      set(CMAKE_CUDA_STANDARD 11)
    endif ()

    set(CMAKE_CUDA_STANDARD_REQUIRED ON CACHE BOOL "" FORCE)

    if (HYPRE_ENABLE_DEVICE_MALLOC_ASYNC)
      set(HYPRE_USING_DEVICE_MALLOC_ASYNC ON CACHE BOOL "" FORCE)
    endif ()

    set(HYPRE_USING_CUDA ON CACHE BOOL "" FORCE)
    set(HYPRE_USING_GPU ON CACHE BOOL "" FORCE)

    if (HYPRE_ENABLE_UNIFIED_MEMORY)
      set(HYPRE_USING_UNIFIED_MEMORY ON CACHE BOOL "" FORCE)
    else ()
      set(HYPRE_USING_DEVICE_MEMORY ON CACHE BOOL "" FORCE)
    endif ()

    # Check if examples are enabled, but not unified memory
    if (HYPRE_BUILD_EXAMPLES AND NOT HYPRE_ENABLE_UNIFIED_MEMORY)

=== src/IJ_mv/CMakeLists.txt ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(HDRS
  aux_parcsr_matrix.h
  aux_par_vector.h
  HYPRE_IJ_mv.h
  _hypre_IJ_mv.h
  IJ_matrix.h
  IJ_vector.h
)

set(SRCS
  aux_parcsr_matrix.c
  aux_par_vector.c
  F90_HYPRE_IJMatrix.c
  F90_HYPRE_IJVector.c
  F90_IJMatrix.c
  HYPRE_IJMatrix.c
  HYPRE_IJVector.c
  IJ_assumed_part.c
  IJMatrix.c
  IJMatrix_parcsr.c
  IJVector.c
  IJVector_parcsr.c
  IJMatrix_parcsr_device.c
  IJVector_parcsr_device.c
)

target_sources(${PROJECT_NAME}
  PRIVATE ${SRCS}
          ${HDRS}
)

if (HYPRE_USING_CUDA OR HYPRE_USING_SYCL)
  set(GPU_SRCS
    IJMatrix_parcsr_device.c
    IJVector_parcsr_device.c
  )
  convert_filenames_to_full_paths(GPU_SRCS)
  set(HYPRE_GPU_SOURCES ${HYPRE_GPU_SOURCES} ${GPU_SRCS} PARENT_SCOPE)
endif ()

convert_filenames_to_full_paths(HDRS)
set(HYPRE_HEADERS ${HYPRE_HEADERS} ${HDRS} PARENT_SCOPE)

=== src/IJ_mv/Makefile ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS =\
 -I..\
 -I$(srcdir)/..\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../struct_mv\
 -I$(srcdir)/../seq_mv\
 -I$(srcdir)/../parcsr_mv\
 -I$(srcdir)/../parcsr_ls\
 ${CINCLUDES}

HEADERS =\
 aux_parcsr_matrix.h\
 aux_par_vector.h\
 HYPRE_IJ_mv.h\
 _hypre_IJ_mv.h\
 IJ_matrix.h\
 IJ_vector.h

EXTRA_FILES =\
 IJMatrix_isis.c\
 IJMatrix_petsc.c

FILES =\
 aux_parcsr_matrix.c\
 aux_par_vector.c\
 F90_HYPRE_IJMatrix.c\
 F90_HYPRE_IJVector.c\
 F90_IJMatrix.c\
 HYPRE_IJMatrix.c\
 HYPRE_IJVector.c\
 IJ_assumed_part.c\
 IJMatrix.c\
 IJMatrix_parcsr.c\
 IJVector.c\
 IJVector_parcsr.c

CUFILES =\
 IJMatrix_parcsr_device.c\
 IJVector_parcsr_device.c

COBJS = ${FILES:.c=.o}
CUOBJS = ${CUFILES:.c=.obj}
OBJS = ${COBJS} ${CUOBJS}

SONAME = libHYPRE_IJ_mv-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_IJ_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_IJ_mv.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_IJ_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_IJ_mv.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o *.obj libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_IJ_mv.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_IJ_mv.so libHYPRE_IJ_mv.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s -f ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/examples/CMakeLists.txt ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(EXAMPLE_SRCS
  ex1.c
  ex2.c
  ex3.c
  ex4.c
  ex5.c
  ex6.c
  ex7.c
  ex8.c
  ex9.c
  ex11.c
  ex12.c
  ex13.c
  ex14.c
  ex15.c
  ex16.c
  ex17.c
  ex18.c
)

if (HYPRE_BIGINT)
  list(APPEND EXAMPLE_SRCS
    ex5big.c
    ex15big.c
  )
endif()

if (HYPRE_COMPLEX)
  list(APPEND EXAMPLE_SRCS
    ex18comp.c
  )
endif()

add_hypre_executables(EXAMPLE_SRCS)

=== src/parcsr_ls/CMakeLists.txt ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(HDRS
  HYPRE_parcsr_ls.h
  _hypre_parcsr_ls.h
)

set(SRCS
  amg_hybrid.c
  aux_interp.c
  F90_hypre_laplace.c
  F90_HYPRE_parcsr_amg.c
  F90_HYPRE_parcsr_bicgstab.c
  F90_HYPRE_parcsr_block.c
  F90_HYPRE_parcsr_cgnr.c
  F90_HYPRE_parcsr_Euclid.c
  F90_HYPRE_parcsr_gmres.c
  F90_HYPRE_parcsr_cogmres.c
  F90_HYPRE_parcsr_flexgmres.c
  F90_HYPRE_parcsr_lgmres.c
  F90_HYPRE_parcsr_hybrid.c
  F90_HYPRE_parcsr_int.c
  F90_HYPRE_parcsr_ParaSails.c
  F90_HYPRE_parcsr_pcg.c
  F90_HYPRE_parcsr_pilut.c
  F90_HYPRE_parcsr_schwarz.c
  F90_HYPRE_ams.c
  gen_redcs_mat.c
  HYPRE_parcsr_amg.c
  HYPRE_parcsr_amgdd.c
  HYPRE_parcsr_bicgstab.c
  HYPRE_parcsr_block.c
  HYPRE_parcsr_cgnr.c
  HYPRE_parcsr_Euclid.c
  HYPRE_parcsr_gmres.c
  HYPRE_parcsr_cogmres.c
  HYPRE_parcsr_flexgmres.c
  HYPRE_parcsr_lgmres.c
  HYPRE_parcsr_hybrid.c
  HYPRE_parcsr_int.c
  HYPRE_parcsr_ilu.c
  HYPRE_parcsr_mgr.c
  HYPRE_parcsr_ParaSails.c
  HYPRE_parcsr_pcg.c
  HYPRE_parcsr_pilut.c
  HYPRE_parcsr_schwarz.c
  HYPRE_parcsr_fsai.c
  HYPRE_ams.c
  HYPRE_ads.c
  HYPRE_ame.c
  par_2s_interp.c
  par_amg.c
  par_amgdd.c
  par_amgdd_comp_grid.c
  par_amgdd_solve.c
  par_amgdd_helpers.c
  par_amgdd_fac_cycle.c
  par_amgdd_setup.c
  par_amg_setup.c
  par_amg_solve.c
  par_amg_solveT.c
  par_cg_relax_wt.c
  par_coarsen.c
  par_cgc_coarsen.c
  par_cheby.c
  par_cheby_device.c
  par_coarse_parms.c
  par_coarse_parms_device.c
  par_coordinates.c
  par_cr.c
  par_cycle.c
  par_add_cycle.c
  par_difconv.c
  par_fsai.c
  par_fsai_setup.c
  par_fsai_solve.c
  par_gauss_elim.c
  par_gsmg.c
  par_indepset.c
  par_interp.c
  par_jacobi_interp.c
  par_krylov_func.c
  par_mod_lr_interp.c
  par_mod_multi_interp.c
  par_multi_interp.c
  par_laplace_27pt.c
  par_laplace_9pt.c
  par_laplace.c
  par_lr_interp.c
  par_mgr.c
  par_mgr_setup.c
  par_mgr_solve.c
  par_nongalerkin.c
  par_nodal_systems.c
  par_rap.c
  par_rap_communication.c
  par_rotate_7pt.c
  par_vardifconv.c
  par_vardifconv_rs.c
  par_relax.c
  par_relax_more.c
  par_relax_more_device.c
  par_relax_interface.c
  par_scaled_matnorm.c
  par_schwarz.c
  par_stats.c
  par_strength.c
  par_sv_interp.c
  par_sv_interp_ln.c
  partial.c
  schwarz.c
  block_tridiag.c
  ams.c
  ads.c
  ame.c
  par_restr.c
  par_lr_restr.c
  par_mgr.c
  par_mgr_setup.c
  par_mgr_solve.c
  par_ilu.c
  par_ilu_setup.c
  par_ilu_solve.c
  par_ilu_solve_device.c
  par_coarsen_device.c
  par_indepset_device.c
  par_interp_device.c
  par_interp_trunc_device.c
  par_lr_interp_device.c
  par_lr_restr_device.c
  par_strength_device.c
  par_strength2nd_device.c
  par_amgdd_fac_cycle_device.c
  par_2s_interp_device.c
  par_relax_device.c
  par_mod_multi_interp_device.c
  par_mgr_device.c
)

if (HYPRE_USING_DSUPERLU)
  list(APPEND SRCS dsuperlu.c)
endif()

target_sources(${PROJECT_NAME}
  PRIVATE ${SRCS}
          ${HDRS}
)

if (HYPRE_USING_CUDA OR HYPRE_USING_SYCL)
  set(GPU_SRCS
    ams.c
    ads.c
    ame.c
    par_amg_setup.c
    par_ilu.c
    par_ilu_setup.c
    par_ilu_solve.c
    par_ilu_solve_device.c
    par_coarsen_device.c
    par_coarse_parms_device.c
    par_indepset_device.c
    par_interp_device.c
    par_interp_trunc_device.c
    par_lr_interp_device.c
    par_lr_restr_device.c
    par_mod_multi_interp_device.c
    par_strength_device.c
    par_strength2nd_device.c
    par_relax_more_device.c
    par_cheby_device.c
    par_amgdd_fac_cycle_device.c
    par_2s_interp_device.c
    par_relax_device.c
    par_mgr_device.c
  )
  convert_filenames_to_full_paths(GPU_SRCS)
  set(HYPRE_GPU_SOURCES ${HYPRE_GPU_SOURCES} ${GPU_SRCS} PARENT_SCOPE)
endif ()

convert_filenames_to_full_paths(HDRS)
set(HYPRE_HEADERS ${HYPRE_HEADERS} ${HDRS} PARENT_SCOPE)

=== src/parcsr_ls/Makefile ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

include ../config/Makefile.config

## Euclid specific macros taken from distributed_ls/Euclid

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS =\
 -I..\
 -I../distributed_ls/Euclid\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../blas\
 -I$(srcdir)/../lapack\
 -I$(srcdir)/../multivector\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../krylov\
 -I$(srcdir)/../seq_mv\
 -I$(srcdir)/../parcsr_mv\
 -I$(srcdir)/../distributed_matrix\
 -I$(srcdir)/../matrix_matrix\
 -I$(srcdir)/../IJ_mv\
 -I$(srcdir)/../parcsr_block_mv\
 $(DSUPERLU_INCLUDE)\
 ${CINCLUDES}

HEADERS =\
 HYPRE_parcsr_ls.h\
 _hypre_parcsr_ls.h\
 aux_interp.h\
 block_tridiag.h\
 Common.h\
 par_amg.h\
 par_amgdd.h\
 par_amgdd_comp_grid.h\
 par_fsai.h\
 schwarz.h

FILES =\
 amg_hybrid.c\
 aux_interp.c\
 F90_hypre_laplace.c\
 F90_HYPRE_parcsr_amg.c\
 F90_HYPRE_parcsr_bicgstab.c\
 F90_HYPRE_parcsr_block.c\
 F90_HYPRE_parcsr_cgnr.c\
 F90_HYPRE_parcsr_Euclid.c\
 F90_HYPRE_parcsr_gmres.c\
 F90_HYPRE_parcsr_cogmres.c\
 F90_HYPRE_parcsr_flexgmres.c\
 F90_HYPRE_parcsr_lgmres.c\
 F90_HYPRE_parcsr_hybrid.c\
 F90_HYPRE_parcsr_int.c\
 F90_HYPRE_parcsr_ParaSails.c\
 F90_HYPRE_parcsr_pcg.c\
 F90_HYPRE_parcsr_pilut.c\
 F90_HYPRE_parcsr_schwarz.c\
 F90_HYPRE_parcsr_mgr.c\
 F90_HYPRE_parcsr_ilu.c\
 F90_HYPRE_ams.c\
 gen_redcs_mat.c\
 HYPRE_parcsr_amg.c\
 HYPRE_parcsr_amgdd.c\
 HYPRE_parcsr_bicgstab.c\
 HYPRE_parcsr_block.c\
 HYPRE_parcsr_cgnr.c\
 HYPRE_parcsr_Euclid.c\
 HYPRE_parcsr_gmres.c\
 HYPRE_parcsr_cogmres.c\
 HYPRE_parcsr_flexgmres.c\
 HYPRE_parcsr_lgmres.c\
 HYPRE_parcsr_hybrid.c\
 HYPRE_parcsr_int.c\
 HYPRE_parcsr_mgr.c\
 HYPRE_parcsr_ilu.c \
 HYPRE_parcsr_fsai.c \
 HYPRE_parcsr_ParaSails.c\
 HYPRE_parcsr_pcg.c\
 HYPRE_parcsr_pilut.c\
 HYPRE_parcsr_schwarz.c\
 HYPRE_ams.c\
 HYPRE_ads.c\
 HYPRE_ame.c\
 par_2s_interp.c\
 par_amg.c\
 par_amgdd.c\
 par_amgdd_comp_grid.c\
 par_amgdd_setup.c\
 par_amgdd_solve.c\
 par_amgdd_fac_cycle.c\
 par_amgdd_helpers.c\
 par_amg_solve.c\
 par_amg_solveT.c\
 par_fsai.c\
 par_fsai_setup.c\
 par_fsai_solve.c\
 par_cg_relax_wt.c\
 par_coarsen.c\
 par_cgc_coarsen.c\
 par_cheby.c\
 par_coarse_parms.c\
 par_coordinates.c\
 par_cr.c\
 par_cycle.c\
 par_add_cycle.c\
 par_difconv.c\
 par_gauss_elim.c\
 par_gsmg.c\
 par_indepset.c\
 par_interp.c\
 par_jacobi_interp.c\
 par_krylov_func.c\
 par_mod_lr_interp.c\
 par_multi_interp.c\
 par_mod_multi_interp.c\
 par_laplace.c\
 par_laplace_27pt.c\
 par_laplace_9pt.c\
 par_lr_interp.c\
 par_mgr.c\
 par_mgr_setup.c\
 par_mgr_solve.c\
 par_nongalerkin.c\
 par_nodal_systems.c\
 par_rap.c\
 par_rap_communication.c\
 par_rotate_7pt.c\
 par_relax.c\
 par_relax_more.c\
 par_relax_interface.c\
 par_scaled_matnorm.c\
 par_schwarz.c\
 par_stats.c\
 par_strength.c\
 par_sv_interp.c\
 par_sv_interp_ln.c\
 par_vardifconv.c\
 par_vardifconv_rs.c\
 partial.c\
 schwarz.c\
 block_tridiag.c\
 par_restr.c\
 par_lr_restr.c\
 dsuperlu.c

CUFILES =\
 ads.c\
 ams.c\
 ame.c\
 par_amg_setup.c\
 par_ilu.c\
 par_ilu_setup.c \
 par_ilu_solve_device.c\
 par_ilu_solve.c \
 par_cheby_device.c\
 par_relax_more_device.c\
 par_coarsen_device.c\
 par_coarse_parms_device.c\
 par_indepset_device.c\
 par_interp_device.c\
 par_lr_restr_device.c\
 par_interp_trunc_device.c\
 par_lr_interp_device.c\
 par_strength_device.c\
 par_strength2nd_device.c\
 par_amgdd_fac_cycle_device.c\
 par_2s_interp_device.c\
 par_relax_device.c\
 par_mod_multi_interp_device.c\
 par_mgr_device.c

COBJS = ${FILES:.c=.o}
CUOBJS = ${CUFILES:.c=.obj}
OBJS = ${COBJS} ${CUOBJS}

SONAME = libHYPRE_parcsr_ls-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_parcsr_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_parcsr_ls.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_parcsr_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_parcsr_ls.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o *.obj libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean


##################################################################
# Rules
##################################################################

libHYPRE_parcsr_ls.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_parcsr_ls.so libHYPRE_parcsr_ls.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s -f ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/parcsr_mv/CMakeLists.txt ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(HDRS
  HYPRE_parcsr_mv.h
  _hypre_parcsr_mv.h
)

set(SRCS
  communicationT.c
  F90_HYPRE_parcsr_matrix.c
  F90_HYPRE_parcsr_vector.c
  F90_parcsr_matrix.c
  F90_par_vector.c
  gen_fffc.c
  HYPRE_parcsr_matrix.c
  HYPRE_parcsr_vector.c
  new_commpkg.c
  numbers.c
  par_csr_aat.c
  par_csr_assumed_part.c
  par_csr_bool_matop.c
  par_csr_bool_matrix.c
  par_csr_communication.c
  par_csr_matop.c
  par_csr_matrix.c
  par_csr_matop_marked.c
  par_csr_matvec.c
  par_csr_matvec_device.c
  par_vector.c
  par_vector_batched.c
  par_make_system.c
  par_csr_triplemat.c
  par_csr_fffc_device.c
  par_csr_matop_device.c
  par_csr_triplemat_device.c
  par_vector_device.c
)

target_sources(${PROJECT_NAME}
  PRIVATE ${SRCS}
          ${HDRS}
)

if (HYPRE_USING_CUDA OR HYPRE_USING_SYCL)
  set(GPU_SRCS
    par_csr_matvec_device.c
    par_csr_fffc_device.c
    par_csr_matop_device.c
    par_csr_triplemat_device.c
    par_vector_device.c
  )
  convert_filenames_to_full_paths(GPU_SRCS)
  set(HYPRE_GPU_SOURCES ${HYPRE_GPU_SOURCES} ${GPU_SRCS} PARENT_SCOPE)
endif ()

convert_filenames_to_full_paths(HDRS)
set(HYPRE_HEADERS ${HYPRE_HEADERS} ${HDRS} PARENT_SCOPE)

=== src/seq_mv/CMakeLists.txt ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(HDRS
  HYPRE_seq_mv.h
  seq_mv.h
)

set(SRCS
  csr_matop.c
  csr_matrix.c
  csr_matvec.c
  genpart.c
  HYPRE_csr_matrix.c
  HYPRE_mapped_matrix.c
  HYPRE_multiblock_matrix.c
  HYPRE_vector.c
  mapped_matrix.c
  multiblock_matrix.c
  vector_batched.c
  csr_matop_device.c
  csr_matrix_cuda_utils.c
  csr_matvec_device.c
  csr_matvec_oomp.c
  csr_spadd_device.c
  csr_spgemm_device.c
  csr_spgemm_device_cusparse.c
  csr_spgemm_device_numblocks.c
  csr_spgemm_device_numer.c
  csr_spgemm_device_numer1.c
  csr_spgemm_device_numer2.c
  csr_spgemm_device_numer3.c
  csr_spgemm_device_numer4.c
  csr_spgemm_device_numer5.c
  csr_spgemm_device_numer6.c
  csr_spgemm_device_numer7.c
  csr_spgemm_device_numer8.c
  csr_spgemm_device_numer9.c
  csr_spgemm_device_numer10.c
  csr_spgemm_device_onemklsparse.c
  csr_spgemm_device_rocsparse.c
  csr_spgemm_device_rowest.c
  csr_spgemm_device_symbl.c
  csr_spgemm_device_symbl1.c
  csr_spgemm_device_symbl2.c
  csr_spgemm_device_symbl3.c
  csr_spgemm_device_symbl4.c
  csr_spgemm_device_symbl5.c
  csr_spgemm_device_symbl6.c
  csr_spgemm_device_symbl7.c
  csr_spgemm_device_symbl8.c
  csr_spgemm_device_symbl9.c
  csr_spgemm_device_symbl10.c
  csr_spgemm_device_util.c
  csr_spmv_device.c
  csr_sptrans_device.c
  vector.c
  vector_device.c
)

# Autogenerate csr_spgemm_device_numer$ files
file(READ "csr_spgemm_device_numer.in" CONTENTS)
foreach(number RANGE 1 10)
  # Check if file exists, then don't recreate
  set(fn "csr_spgemm_device_numer${number}.c")
  if (NOT EXISTS ${fn})
    file(WRITE ${fn} "#define HYPRE_SPGEMM_BIN ${number}")
    file(APPEND ${fn} "${CONTENTS}")
  endif (NOT EXISTS ${fn})
endforeach(number RANGE 1 10)

# Autogenerate csr_spgemm_device_symbl$ files
file(READ "csr_spgemm_device_symbl.in" CONTENTS)
foreach(number RANGE 1 10)
  set(fn "csr_spgemm_device_symbl${number}.c")
  if (NOT EXISTS ${fn})
    file(WRITE ${fn} "#define HYPRE_SPGEMM_BIN ${number}")
    file(APPEND ${fn} "${CONTENTS}")
  endif (NOT EXISTS ${fn})
endforeach(number RANGE 1 10)

target_sources(${PROJECT_NAME}
  PRIVATE ${SRCS}
          ${HDRS}
)

if (HYPRE_USING_CUDA OR HYPRE_USING_SYCL)
  set(GPU_SRCS
    csr_matop_device.c
    csr_matrix_cuda_utils.c
    csr_matvec_device.c
    csr_matvec_oomp.c
    csr_spadd_device.c
    csr_spgemm_device.c
    csr_spgemm_device_cusparse.c
    csr_spgemm_device_numblocks.c
    csr_spgemm_device_numer.c
    csr_spgemm_device_numer1.c
    csr_spgemm_device_numer2.c
    csr_spgemm_device_numer3.c
    csr_spgemm_device_numer4.c
    csr_spgemm_device_numer5.c
    csr_spgemm_device_numer6.c
    csr_spgemm_device_numer7.c
    csr_spgemm_device_numer8.c
    csr_spgemm_device_numer9.c
    csr_spgemm_device_numer10.c
    csr_spgemm_device_onemklsparse.c
    csr_spgemm_device_rocsparse.c
    csr_spgemm_device_rowest.c
    csr_spgemm_device_symbl.c
    csr_spgemm_device_symbl1.c
    csr_spgemm_device_symbl2.c
    csr_spgemm_device_symbl3.c
    csr_spgemm_device_symbl4.c
    csr_spgemm_device_symbl5.c
    csr_spgemm_device_symbl6.c
    csr_spgemm_device_symbl7.c
    csr_spgemm_device_symbl8.c
    csr_spgemm_device_symbl9.c
    csr_spgemm_device_symbl10.c
    csr_spgemm_device_util.c
    csr_spmv_device.c
    csr_sptrans_device.c
    vector_device.c
  )
  convert_filenames_to_full_paths(GPU_SRCS)
  set(HYPRE_GPU_SOURCES ${HYPRE_GPU_SOURCES} ${GPU_SRCS} PARENT_SCOPE)
endif ()

convert_filenames_to_full_paths(HDRS)
set(HYPRE_HEADERS ${HYPRE_HEADERS} ${HDRS} PARENT_SCOPE)

=== src/seq_mv/Makefile ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS =\
 -I..\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../utilities\
 ${CINCLUDES}

HEADERS =\
 csr_matrix.h\
 HYPRE_seq_mv.h\
 mapped_matrix.h\
 multiblock_matrix.h\
 seq_mv.h\
 seq_mv.hpp\
 vector.h

FILES =\
 csr_matop.c\
 csr_matrix.c\
 csr_matvec.c\
 genpart.c\
 HYPRE_csr_matrix.c\
 HYPRE_mapped_matrix.c\
 HYPRE_multiblock_matrix.c\
 HYPRE_vector.c\
 mapped_matrix.c\
 multiblock_matrix.c\
 vector.c\
 vector_batched.c

CUFILES =\
 csr_matop_device.c\
 csr_matrix_cuda_utils.c\
 csr_matvec_device.c\
 csr_matvec_oomp.c\
 csr_spadd_device.c\
 csr_spgemm_device.c\
 csr_spgemm_device_cusparse.c\
 csr_spgemm_device_numblocks.c\
 csr_spgemm_device_numer.c\
 csr_spgemm_device_numer1.c\
 csr_spgemm_device_numer2.c\
 csr_spgemm_device_numer3.c\
 csr_spgemm_device_numer4.c\
 csr_spgemm_device_numer5.c\
 csr_spgemm_device_numer6.c\
 csr_spgemm_device_numer7.c\
 csr_spgemm_device_numer8.c\
 csr_spgemm_device_numer9.c\
 csr_spgemm_device_numer10.c\
 csr_spgemm_device_onemklsparse.c\
 csr_spgemm_device_rocsparse.c \
 csr_spgemm_device_rowest.c\
 csr_spgemm_device_symbl.c\
 csr_spgemm_device_symbl1.c\
 csr_spgemm_device_symbl2.c\
 csr_spgemm_device_symbl3.c\
 csr_spgemm_device_symbl4.c\
 csr_spgemm_device_symbl5.c\
 csr_spgemm_device_symbl6.c\
 csr_spgemm_device_symbl7.c\
 csr_spgemm_device_symbl8.c\
 csr_spgemm_device_symbl9.c\
 csr_spgemm_device_symbl10.c\
 csr_spgemm_device_util.c\
 csr_spmv_device.c\
 csr_sptrans_device.c\
 vector_device.c

COBJS = ${FILES:.c=.o}
CUOBJS = ${CUFILES:.c=.obj}
OBJS = ${COBJS} ${CUOBJS}

SONAME = libHYPRE_seq_mv-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all:
	$(MAKE) autogen
	$(MAKE) lib

lib: libHYPRE_seq_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/seq_mv.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_seq_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/seq_mv.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean: deleteautogen
	rm -f *.o *.obj libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

autogen:
	@for number in 1 2 3 4 5 6 7 8 9 10; do \
	   fn=csr_spgemm_device_numer$$number.c; \
	   if [ ! -f $$fn ]; then \
	      echo "#define HYPRE_SPGEMM_BIN $$number" > $$fn; \
	      cat csr_spgemm_device_numer.in >> $$fn; \
	   fi \
	   done
	@for number in 1 2 3 4 5 6 7 8 9 10; do \
	   fn=csr_spgemm_device_symbl$$number.c; \
	   if [ ! -f $$fn ]; then \
	      echo "#define HYPRE_SPGEMM_BIN $$number" > $$fn; \
	      cat csr_spgemm_device_symbl.in >> $$fn; \
	   fi \
	   done

deleteautogen:
	rm -f csr_spgemm_device_numer[1-9].c
	rm -f csr_spgemm_device_numer10.c
	rm -f csr_spgemm_device_symbl[1-9].c
	rm -f csr_spgemm_device_symbl10.c

##################################################################
# Rules
##################################################################

libHYPRE_seq_mv.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_seq_mv.so libHYPRE_seq_mv.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s -f ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/sstruct_mv/Makefile ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS = \
 -I..\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../struct_mv\
 -I$(srcdir)/../seq_mv\
 -I$(srcdir)/../parcsr_mv\
 -I$(srcdir)/../IJ_mv\
 ${CINCLUDES}

HEADERS =\
 HYPRE_sstruct_mv.h\
 _hypre_sstruct_mv.h\
 sstruct_graph.h\
 sstruct_grid.h\
 sstruct_matrix.h\
 sstruct_stencil.h\
 sstruct_vector.h

FILES =\
 F90_HYPRE_sstruct_graph.c\
 F90_HYPRE_sstruct_grid.c\
 F90_HYPRE_sstruct_matrix.c\
 F90_HYPRE_sstruct_stencil.c\
 F90_HYPRE_sstruct_vector.c\
 HYPRE_sstruct_graph.c\
 HYPRE_sstruct_grid.c\
 HYPRE_sstruct_matrix.c\
 HYPRE_sstruct_stencil.c\
 HYPRE_sstruct_vector.c\
 sstruct_axpy.c\
 sstruct_copy.c\
 sstruct_graph.c\
 sstruct_grid.c\
 sstruct_innerprod.c\
 sstruct_matvec.c\
 sstruct_scale.c\
 sstruct_stencil.c

CUFILES =\
 sstruct_matrix.c\
 sstruct_vector.c

COBJS = ${FILES:.c=.o}
CUOBJS = ${CUFILES:.c=.obj}
OBJS = ${COBJS} ${CUOBJS}

SONAME = libHYPRE_sstruct_mv-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_sstruct_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_sstruct_mv.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_sstruct_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_sstruct_mv.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o *.obj libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_sstruct_mv.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_sstruct_mv.so libHYPRE_sstruct_mv.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s -f ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/struct_ls/CMakeLists.txt ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

set(HDRS
  HYPRE_struct_ls.h
  _hypre_struct_ls.h
)

set(SRCS
  coarsen.c
  cyclic_reduction.c
  F90_HYPRE_struct_bicgstab.c
  F90_HYPRE_struct_cycred.c
  F90_HYPRE_struct_gmres.c
  F90_HYPRE_struct_hybrid.c
  F90_HYPRE_struct_int.c
  F90_HYPRE_struct_jacobi.c
  F90_HYPRE_struct_pcg.c
  F90_HYPRE_struct_pfmg.c
  F90_HYPRE_struct_smg.c
  F90_HYPRE_struct_sparse_msg.c
  hybrid.c
  HYPRE_struct_bicgstab.c
  HYPRE_struct_cycred.c
  HYPRE_struct_hybrid.c
  HYPRE_struct_int.c
  HYPRE_struct_jacobi.c
  HYPRE_struct_pfmg.c
  HYPRE_struct_smg.c
  HYPRE_struct_sparse_msg.c
  HYPRE_struct_pcg.c
  HYPRE_struct_gmres.c
  HYPRE_struct_flexgmres.c
  HYPRE_struct_lgmres.c
  jacobi.c
  pcg_struct.c
  pfmg2_setup_rap.c
  pfmg3_setup_rap.c
  pfmg.c
  pfmg_relax.c
  pfmg_setup.c
  pfmg_setup_interp.c
  pfmg_setup_rap5.c
  pfmg_setup_rap7.c
  pfmg_setup_rap.c
  pfmg_solve.c
  point_relax.c
  red_black_constantcoef_gs.c
  red_black_gs.c
  semi.c
  semi_interp.c
  semi_restrict.c
  semi_setup_rap.c
  smg2_setup_rap.c
  smg3_setup_rap.c
  smg_axpy.c
  smg.c
  smg_relax.c
  smg_residual.c
  smg_setup.c
  smg_setup_interp.c
  smg_setup_rap.c
  smg_setup_restrict.c
  smg_solve.c
  sparse_msg2_setup_rap.c
  sparse_msg3_setup_rap.c
  sparse_msg.c
  sparse_msg_filter.c
  sparse_msg_interp.c
  sparse_msg_restrict.c
  sparse_msg_setup.c
  sparse_msg_setup_rap.c
  sparse_msg_solve.c
)
target_sources(${PROJECT_NAME}
  PRIVATE ${SRCS}
          ${HDRS}
)

if (HYPRE_USING_CUDA OR HYPRE_USING_SYCL)
  set(GPU_SRCS
    cyclic_reduction.c
    HYPRE_struct_int.c
    HYPRE_struct_pcg.c
    pfmg2_setup_rap.c
    pfmg3_setup_rap.c
    pfmg_setup.c
    pfmg_setup_interp.c
    pfmg_setup_rap5.c
    pfmg_setup_rap7.c
    point_relax.c
    red_black_constantcoef_gs.c
    red_black_gs.c
    semi_interp.c
    semi_restrict.c
    semi_setup_rap.c
    smg2_setup_rap.c
    smg3_setup_rap.c
    smg.c
    smg_axpy.c
    smg_residual.c
    smg_setup_interp.c
    sparse_msg2_setup_rap.c
    sparse_msg3_setup_rap.c
    sparse_msg_filter.c
    sparse_msg_interp.c
    sparse_msg_restrict.c
  )
  convert_filenames_to_full_paths(GPU_SRCS)
  set(HYPRE_GPU_SOURCES ${HYPRE_GPU_SOURCES} ${GPU_SRCS} PARENT_SCOPE)
endif ()

convert_filenames_to_full_paths(HDRS)
set(HYPRE_HEADERS ${HYPRE_HEADERS} ${HDRS} PARENT_SCOPE)

=== src/struct_ls/Makefile ===
# Copyright (c) 1998 Lawrence Livermore National Security, LLC and other
# HYPRE Project Developers. See the top-level COPYRIGHT file for details.
#
# SPDX-License-Identifier: (Apache-2.0 OR MIT)

include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS = \
 -I..\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../multivector\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../krylov\
 -I$(srcdir)/../struct_mv\
 ${CINCLUDES}

HEADERS =\
 HYPRE_struct_ls.h\
 _hypre_struct_ls.h\
 pfmg.h\
 red_black_gs.h\
 smg.h\
 sparse_msg.h

FILES =\
 coarsen.c\
 F90_HYPRE_struct_bicgstab.c\
 F90_HYPRE_struct_cycred.c\
 F90_HYPRE_struct_flexgmres.c\
 F90_HYPRE_struct_gmres.c\
 F90_HYPRE_struct_lgmres.c\
 F90_HYPRE_struct_hybrid.c\
 F90_HYPRE_struct_int.c\
 F90_HYPRE_struct_jacobi.c\
 F90_HYPRE_struct_pcg.c\
 F90_HYPRE_struct_pfmg.c\
 F90_HYPRE_struct_smg.c\
 F90_HYPRE_struct_sparse_msg.c\
 hybrid.c\
 HYPRE_struct_bicgstab.c\
 HYPRE_struct_cycred.c\
 HYPRE_struct_flexgmres.c\
 HYPRE_struct_gmres.c\
 HYPRE_struct_hybrid.c\
 HYPRE_struct_jacobi.c\
 HYPRE_struct_lgmres.c\
 HYPRE_struct_pfmg.c\
 HYPRE_struct_smg.c\
 HYPRE_struct_sparse_msg.c\
 jacobi.c\
 pcg_struct.c\
 pfmg.c\
 pfmg_relax.c\
 pfmg_setup_rap.c\
 pfmg_solve.c\
 semi.c\
 smg_relax.c\
 smg_setup.c\
 smg_setup_rap.c\
 smg_setup_restrict.c\
 smg_solve.c\
 sparse_msg.c\
 sparse_msg_setup.c\
 sparse_msg_setup_rap.c\
 sparse_msg_solve.c

CUFILES =\
 cyclic_reduction.c\
 HYPRE_struct_int.c\
 HYPRE_struct_pcg.c\
 pfmg2_setup_rap.c\
 pfmg3_setup_rap.c\
 pfmg_setup.c\
 pfmg_setup_interp.c\
 pfmg_setup_rap5.c\
 pfmg_setup_rap7.c\
 point_relax.c\
 red_black_constantcoef_gs.c\
 red_black_gs.c\
 semi_interp.c\
 semi_restrict.c\
 semi_setup_rap.c\
 smg2_setup_rap.c\
 smg3_setup_rap.c\
 smg.c\
 smg_axpy.c\
 smg_residual.c\
 smg_setup_interp.c\
 sparse_msg2_setup_rap.c\
 sparse_msg3_setup_rap.c\
 sparse_msg_filter.c\
 sparse_msg_interp.c\
 sparse_msg_restrict.c

COBJS = ${FILES:.c=.o}
CUOBJS = ${CUFILES:.c=.obj}
OBJS = ${COBJS} ${CUOBJS}

SONAME = libHYPRE_struct_ls-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_struct_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_struct_ls.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_struct_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_struct_ls.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o *.obj libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_struct_ls.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_struct_ls.so libHYPRE_struct_ls.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s -f ${SONAME} $@

${OBJS}: ${HEADERS}

=== debian/changelog ===
hypre (2.28.0-2) unstable; urgency=medium

  * Team upload.
  * push HYPRE 2.28.0 to unstable. Transition #1042005.

 -- Drew Parsons <dparsons@debian.org>  Sat, 05 Aug 2023 17:29:43 +0200

hypre (2.28.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * drop deprecated debian patch pilut_blas_mangle.patch. External
    BLAS handling fixed in PR#36 (commit a16e7b3 for PETSc 2.18).
    See also commit 5afacfc in PR#827.
  * debian/tests: launch runtest.sh explicitly via bash to avoid
    problems from hashbang #!/bin/sh (script uses function keyword)
    See https://github.com/hypre-space/hypre/issues/881

 -- Drew Parsons <dparsons@debian.org>  Sun, 16 Apr 2023 18:20:50 +0200

hypre (2.27.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Sat, 31 Dec 2022 11:05:53 +0100

=== debian/control ===
Source: hypre
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>
Standards-Version: 4.6.2
Build-Depends:
 autoconf,
 automake,
 debhelper-compat (= 13),
 pkg-config,
 gfortran,
 libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
 liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
 libblas64-dev [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libopenblas64-dev [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libatlas-base-dev  [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libblas64.so [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32],
 liblapack64-dev  [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libopenblas64-dev [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | libatlas-base-dev  [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !sh4 !x32]
   | liblapack64.so [!armel !armhf !i386 !mipsel !hppa !hurd-i386 !kfreebsd-i386 !m68k !powerpc !sh4 !x32],
 libsuperlu-dev, libsuperlu-dist-dev (>= 6.3),
 libltdl-dev,
 libtool,
 mpi-default-dev,
Vcs-Git: https://salsa.debian.org/science-team/hypre.git
Vcs-Browser: https://salsa.debian.org/science-team/hypre
Homepage: https://www.llnl.gov/casc/hypre/

Package: libhypre-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends:
 libhypre-2.28.0 (= ${binary:Version}),
 libopenblas-dev | libatlas-base-dev | libblas-dev | libblas.so,
 libopenblas-dev | libatlas-base-dev | liblapack-dev | liblapack.so,
 libsuperlu-dev,
 mpi-default-dev,
 ${misc:Depends},
Description: High Performance Matrix Preconditioners - Development Files
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the headers and symlinks necessary to develop
 programs which use hypre.

Package: libhypre-2.28.0
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: High Performance Matrix Preconditioners - Shared Library
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the shared library.

Package: libhypre64-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends:
 libhypre64-2.28.0 (= ${binary:Version}),
 libopenblas64-dev | libblas64-dev | libblas64.so,
 libopenblas64-dev | liblapack64-dev | liblapack64.so,
 libsuperlu-dev,
 mpi-default-dev,
 ${misc:Depends},
Description: High Performance Matrix Preconditioners - 64-bit (bigint) Development Files
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the headers and symlinks necessary to develop
 programs which use hypre with 64-bit integers for both HYPRE_BigInt
 and HYPRE_Int (--with-bigint).

Package: libhypre64-2.28.0
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: High Performance Matrix Preconditioners - 64-bit (bigint) Shared Library
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the shared library supporting 64-bit integers
 for both HYPRE_BigInt and HYPRE_Int (--with-bigint).

Package: libhypre64m-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends:
 libhypre64m-2.28.0 (= ${binary:Version}),
 libopenblas64-dev | libblas64-dev | libblas64.so,
 libopenblas64-dev | liblapack64-dev | liblapack64.so,
 libsuperlu-dev,
 mpi-default-dev,
 ${misc:Depends},
Description: High Performance Matrix Preconditioners - 64-bit (mixedint) Development Files
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the headers and symlinks necessary to develop
 programs which use hypre with 64-bit HYPRE_BigInt and 32-bit HYPRE_Int
 (--with-mixedint).
 .
 Note that segfaults have been reported in MPI tests. libhypre64m
 (mixedint) might not be safe, and should be considered experimental.
 Use with care (or do not use). See
 https://github.com/hypre-space/hypre/issues/326



Package: libhypre64m-2.28.0
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: High Performance Matrix Preconditioners - 64-bit (mixedint) Shared Library
 Hypre is a set of matrix preconditioning libraries to aid in the
 solution of large systems of linear equations.
 .
 This package contains the shared library supporting 64-bit
 HYPRE_BigInt with 32-bit HYPRE_Int (--with-mixedint).
 .
 Note that segfaults have been reported in MPI tests. libhypre64m
 (mixedint) might not be safe, and should be considered experimental.
 Use with care (or do not use). See
 https://github.com/hypre-space/hypre/issues/326

=== debian/tests/control ===
Tests: test-hypre
Depends: libhypre-dev, @builddeps@
Architecture: !armhf

# hypre64 is not available on 32-bit systems (because of blas64 restrictions)
Tests: test-hypre64, test-hypre64m
Depends: libhypre64-dev, libhypre64m-dev, @builddeps@
Architecture: amd64 arm64 mips64el ppc64el s390x alpha kfreebsd-amd64 ia64 ppc64 riscv64 sparc64
